Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp	(revision 88)
@@ -421,18 +553,18 @@
 					dest,"gpr_read_"+toString(2*i+1));
 #endif
-	     PORT_MAP(_component ,src ,"out_GPR_READ_0_VAL"          , dest, "in_GPR_READ_"+toString(2*i  )+"_VAL"          );
-	     PORT_MAP(_component ,src , "in_GPR_READ_0_ACK"          , dest,"out_GPR_READ_"+toString(2*i  )+"_ACK"          );
+	     COMPONENT_MAP(_component ,src ,"out_GPR_READ_0_VAL"          , dest, "in_GPR_READ_"+toString(2*i  )+"_VAL"          );
+	     COMPONENT_MAP(_component ,src , "in_GPR_READ_0_ACK"          , dest,"out_GPR_READ_"+toString(2*i  )+"_ACK"          );
 	     if (_param->_have_port_ooo_engine_id)
-	     PORT_MAP(_component ,src ,"out_GPR_READ_0_OOO_ENGINE_ID", dest, "in_GPR_READ_"+toString(2*i  )+"_OOO_ENGINE_ID");
-	     PORT_MAP(_component ,src ,"out_GPR_READ_0_NUM_REG"      , dest, "in_GPR_READ_"+toString(2*i  )+"_NUM_REG"      );
-	     PORT_MAP(_component ,src , "in_GPR_READ_0_DATA"         , dest,"out_GPR_READ_"+toString(2*i  )+"_DATA"         );
-	     PORT_MAP(_component ,src , "in_GPR_READ_0_DATA_VAL"     , dest,"out_GPR_READ_"+toString(2*i  )+"_DATA_VAL"     );
-	     PORT_MAP(_component ,src ,"out_GPR_READ_1_VAL"          , dest, "in_GPR_READ_"+toString(2*i+1)+"_VAL"          );
-	     PORT_MAP(_component ,src , "in_GPR_READ_1_ACK"          , dest,"out_GPR_READ_"+toString(2*i+1)+"_ACK"          );
+	     COMPONENT_MAP(_component ,src ,"out_GPR_READ_0_OOO_ENGINE_ID", dest, "in_GPR_READ_"+toString(2*i  )+"_OOO_ENGINE_ID");
+	     COMPONENT_MAP(_component ,src ,"out_GPR_READ_0_NUM_REG"      , dest, "in_GPR_READ_"+toString(2*i  )+"_NUM_REG"      );
+	     COMPONENT_MAP(_component ,src , "in_GPR_READ_0_DATA"         , dest,"out_GPR_READ_"+toString(2*i  )+"_DATA"         );
+	     COMPONENT_MAP(_component ,src , "in_GPR_READ_0_DATA_VAL"     , dest,"out_GPR_READ_"+toString(2*i  )+"_DATA_VAL"     );
+	     COMPONENT_MAP(_component ,src ,"out_GPR_READ_1_VAL"          , dest, "in_GPR_READ_"+toString(2*i+1)+"_VAL"          );
+	     COMPONENT_MAP(_component ,src , "in_GPR_READ_1_ACK"          , dest,"out_GPR_READ_"+toString(2*i+1)+"_ACK"          );
 	     if (_param->_have_port_ooo_engine_id)
-	     PORT_MAP(_component ,src ,"out_GPR_READ_1_OOO_ENGINE_ID", dest, "in_GPR_READ_"+toString(2*i+1)+"_OOO_ENGINE_ID");
-	     PORT_MAP(_component ,src ,"out_GPR_READ_1_NUM_REG"      , dest, "in_GPR_READ_"+toString(2*i+1)+"_NUM_REG"      );
-	     PORT_MAP(_component ,src , "in_GPR_READ_1_DATA"         , dest,"out_GPR_READ_"+toString(2*i+1)+"_DATA"         );
-	     PORT_MAP(_component ,src , "in_GPR_READ_1_DATA_VAL"     , dest,"out_GPR_READ_"+toString(2*i+1)+"_DATA_VAL"     );
+	     COMPONENT_MAP(_component ,src ,"out_GPR_READ_1_OOO_ENGINE_ID", dest, "in_GPR_READ_"+toString(2*i+1)+"_OOO_ENGINE_ID");
+	     COMPONENT_MAP(_component ,src ,"out_GPR_READ_1_NUM_REG"      , dest, "in_GPR_READ_"+toString(2*i+1)+"_NUM_REG"      );
+	     COMPONENT_MAP(_component ,src , "in_GPR_READ_1_DATA"         , dest,"out_GPR_READ_"+toString(2*i+1)+"_DATA"         );
+	     COMPONENT_MAP(_component ,src , "in_GPR_READ_1_DATA_VAL"     , dest,"out_GPR_READ_"+toString(2*i+1)+"_DATA_VAL"     );
 	   }
 	   
@@ -442,13 +574,13 @@
 #ifdef POSITION
 	     _component->interface_map (src ,"spr_read_0",
-					dest,"spr_read_"+toString(2*i  ));
-#endif
-	     PORT_MAP(_component ,src ,"out_SPR_READ_0_VAL"          , dest, "in_SPR_READ_"+toString(2*i  )+"_VAL"          );
-	     PORT_MAP(_component ,src , "in_SPR_READ_0_ACK"          , dest,"out_SPR_READ_"+toString(2*i  )+"_ACK"          );
+					dest,"spr_read_"+toString(i));
+#endif
+	     COMPONENT_MAP(_component ,src ,"out_SPR_READ_0_VAL"          , dest, "in_SPR_READ_"+toString(i)+"_VAL"          );
+	     COMPONENT_MAP(_component ,src , "in_SPR_READ_0_ACK"          , dest,"out_SPR_READ_"+toString(i)+"_ACK"          );
 	     if (_param->_have_port_ooo_engine_id)
-	     PORT_MAP(_component ,src ,"out_SPR_READ_0_OOO_ENGINE_ID", dest, "in_SPR_READ_"+toString(2*i  )+"_OOO_ENGINE_ID");
-	     PORT_MAP(_component ,src ,"out_SPR_READ_0_NUM_REG"      , dest, "in_SPR_READ_"+toString(2*i  )+"_NUM_REG"      );
-	     PORT_MAP(_component ,src , "in_SPR_READ_0_DATA"         , dest,"out_SPR_READ_"+toString(2*i  )+"_DATA"         );
-	     PORT_MAP(_component ,src , "in_SPR_READ_0_DATA_VAL"     , dest,"out_SPR_READ_"+toString(2*i  )+"_DATA_VAL"     );
+	     COMPONENT_MAP(_component ,src ,"out_SPR_READ_0_OOO_ENGINE_ID", dest, "in_SPR_READ_"+toString(i)+"_OOO_ENGINE_ID");
+	     COMPONENT_MAP(_component ,src ,"out_SPR_READ_0_NUM_REG"      , dest, "in_SPR_READ_"+toString(i)+"_NUM_REG"      );
+	     COMPONENT_MAP(_component ,src , "in_SPR_READ_0_DATA"         , dest,"out_SPR_READ_"+toString(i)+"_DATA"         );
+	     COMPONENT_MAP(_component ,src , "in_SPR_READ_0_DATA_VAL"     , dest,"out_SPR_READ_"+toString(i)+"_DATA_VAL"     );
 	   }
 	   
@@ -459,35 +591,21 @@
 		it++)
 	     {
-	       dest = _name+"_write_unit_"+toString(*it);
+	       uint32_t num_port = (*it);
+
+	       dest = _name+"_glue";
 #ifdef POSITION
 	       _component->interface_map (src ,"gpr_write_"+toString(it_gpr_write),
-					  dest,"gpr_write");
+					  dest,"gpr_write_read_unit_"+toString(num_port));
 #endif
 	       
-	       PORT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_VAL"          ,
-				    dest,"out_GPR_WRITE_0_VAL"          );
+	       COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_VAL"          ,
+			                 dest,"out_GPR_WRITE_READ_UNIT_"+toString(num_port)+"_VAL"          );
 	       if (_param->_have_port_ooo_engine_id)
-	       PORT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_OOO_ENGINE_ID",
-				    dest,"out_GPR_WRITE_0_OOO_ENGINE_ID");
-	       PORT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_NUM_REG"      ,
-				    dest,"out_GPR_WRITE_0_NUM_REG"      );
-	       PORT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_DATA"         ,
-				    dest,"out_GPR_WRITE_0_DATA"         );
-
-	       // PORT MAP to the "write_unit" component
-#ifdef POSITION
-	       _component->interface_map (dest,"gpr_write",
-					  src ,"gpr_write_"+toString(it_gpr_write));
-#endif
-	       
-	       PORT_MAP(_component ,dest,"out_GPR_WRITE_0_VAL"          ,
-				    src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_VAL"          );
-	       if (_param->_have_port_ooo_engine_id)
-	       PORT_MAP(_component ,dest,"out_GPR_WRITE_0_OOO_ENGINE_ID",
-				    src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_OOO_ENGINE_ID");
-	       PORT_MAP(_component ,dest,"out_GPR_WRITE_0_NUM_REG"      ,
-				    src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_NUM_REG"      );
-	       PORT_MAP(_component ,dest,"out_GPR_WRITE_0_DATA"         ,
-				    src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_DATA"         );
+	       COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_OOO_ENGINE_ID",
+				         dest,"out_GPR_WRITE_READ_UNIT_"+toString(num_port)+"_OOO_ENGINE_ID");
+	       COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_NUM_REG"      ,
+				         dest,"out_GPR_WRITE_READ_UNIT_"+toString(num_port)+"_NUM_REG"      );
+	       COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(it_gpr_write)+"_DATA"         ,
+				         dest,"out_GPR_WRITE_READ_UNIT_"+toString(num_port)+"_DATA"         );
 	       
 	       it_gpr_write ++;
@@ -500,35 +618,23 @@
 		it++)
 	     {
-	       dest = _name+"_write_unit_"+toString(*it);
+	       uint32_t num_port = (*it);
+
+	       dest = _name+"_glue";
 #ifdef POSITION
 	       _component->interface_map (src ,"spr_write_"+toString(it_spr_write),
-					  dest,"spr_write");
+					  dest,"spr_write_read_unit_"+toString(num_port));
 #endif
 	       
-	       PORT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_VAL"          ,
-				    dest,"out_SPR_WRITE_0_VAL"          );
+	       COMPONENT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_VAL"          ,
+			                 dest,"out_SPR_WRITE_READ_UNIT_"+toString(num_port)+"_VAL"          );
+
 	       if (_param->_have_port_ooo_engine_id)
-	       PORT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_OOO_ENGINE_ID",
-				    dest,"out_SPR_WRITE_0_OOO_ENGINE_ID");
-	       PORT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_NUM_REG"      ,
-				    dest,"out_SPR_WRITE_0_NUM_REG"      );
-	       PORT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_DATA"         ,
-				    dest,"out_SPR_WRITE_0_DATA"         );
-
-	       // PORT MAP to the "write_unit" component
-#ifdef POSITION
-	       _component->interface_map (dest,"spr_write",
-					  src ,"spr_write_"+toString(it_spr_write));
-#endif
-	       PORT_MAP(_component ,dest,"out_SPR_WRITE_0_VAL"          ,
-				    src , "in_SPR_WRITE_"+toString(it_spr_write)+"_VAL"          );
-	       if (_param->_have_port_ooo_engine_id)
-	       PORT_MAP(_component ,dest,"out_SPR_WRITE_0_OOO_ENGINE_ID",
-				    src , "in_SPR_WRITE_"+toString(it_spr_write)+"_OOO_ENGINE_ID");
-	       PORT_MAP(_component ,dest,"out_SPR_WRITE_0_NUM_REG"      ,
-				    src , "in_SPR_WRITE_"+toString(it_spr_write)+"_NUM_REG"      );
-	       PORT_MAP(_component ,dest,"out_SPR_WRITE_0_DATA"         ,
-				    src , "in_SPR_WRITE_"+toString(it_spr_write)+"_DATA"         );
-
+	       COMPONENT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_OOO_ENGINE_ID",
+				         dest,"out_SPR_WRITE_READ_UNIT_"+toString(num_port)+"_OOO_ENGINE_ID");
+	       COMPONENT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_NUM_REG"      ,
+				         dest,"out_SPR_WRITE_READ_UNIT_"+toString(num_port)+"_NUM_REG"      );
+	       COMPONENT_MAP(_component ,src , "in_SPR_WRITE_"+toString(it_spr_write)+"_DATA"         ,
+				         dest,"out_SPR_WRITE_READ_UNIT_"+toString(num_port)+"_DATA"         );
+	       
 	       it_spr_write ++;
 	     }
@@ -550,18 +656,18 @@
 		   
 		   if (_param->_have_port_ooo_engine_id)
-		   PORT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_OOO_ENGINE_ID",
-					dest,"out_BYPASS_WRITE_"+toString(j              )+"_OOO_ENGINE_ID");
-		   PORT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_VAL"      ,
-					dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_VAL"      );
-		   PORT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_NUM_REG"  ,
-					dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_NUM_REG"  );
-		   PORT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_DATA"     ,
-					dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_DATA"     );
-		   PORT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_VAL"      ,
-					dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_VAL"      );
-		   PORT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_NUM_REG"  ,
-					dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_NUM_REG"  );
-		   PORT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_DATA"     ,
-					dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_DATA"     );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_OOO_ENGINE_ID",
+					     dest,"out_BYPASS_WRITE_"+toString(j              )+"_OOO_ENGINE_ID");
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_VAL"      ,
+					     dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_VAL"      );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_NUM_REG"  ,
+					     dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_NUM_REG"  );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_DATA"     ,
+					     dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_DATA"     );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_VAL"      ,
+					     dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_VAL"      );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_NUM_REG"  ,
+					     dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_NUM_REG"  );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_DATA"     ,
+					     dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_DATA"     );
 
 #ifdef POSITION
@@ -570,19 +676,19 @@
 #endif
 		   
-		   if (_param->_have_port_ooo_engine_id)
-		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_OOO_ENGINE_ID",
-					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_OOO_ENGINE_ID");
-		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_VAL"      ,
-					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_VAL"      );
-		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_NUM_REG"  ,
-					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_NUM_REG"  );
-		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_DATA"     ,
-					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_DATA"     );
-		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_VAL"      ,
-					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_VAL"      );
-		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_NUM_REG"  ,
-					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_NUM_REG"  );
-		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_DATA"     ,
-					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_DATA"     );
+// 		   if (_param->_have_port_ooo_engine_id)
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_OOO_ENGINE_ID",
+// 					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_OOO_ENGINE_ID");
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_VAL"      ,
+// 					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_VAL"      );
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_NUM_REG"  ,
+// 					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_NUM_REG"  );
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_GPR_DATA"     ,
+// 					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_GPR_DATA"     );
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_VAL"      ,
+// 					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_VAL"      );
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_NUM_REG"  ,
+// 					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_NUM_REG"  );
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_WRITE_"+toString(j              )+"_SPR_DATA"     ,
+// 					src , "in_BYPASS_WRITE_"+toString(it_bypass_write)+"_SPR_DATA"     );
 
 		   it_bypass_write ++;
@@ -606,12 +712,12 @@
 		   
 		   if (_param->_have_port_ooo_engine_id)
-		   PORT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_OOO_ENGINE_ID",
-					dest,"out_BYPASS_MEMORY_"+toString(j               )+"_OOO_ENGINE_ID");
-		   PORT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_VAL"          ,
-					dest,"out_BYPASS_MEMORY_"+toString(j               )+"_VAL"          );
-		   PORT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_NUM_REG"      ,
-					dest,"out_BYPASS_MEMORY_"+toString(j               )+"_NUM_REG"      );
-		   PORT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_DATA"         ,
-					dest,"out_BYPASS_MEMORY_"+toString(j               )+"_DATA"         );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_OOO_ENGINE_ID",
+					     dest,"out_BYPASS_MEMORY_"+toString(j               )+"_OOO_ENGINE_ID");
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_VAL"          ,
+					     dest,"out_BYPASS_MEMORY_"+toString(j               )+"_VAL"          );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_NUM_REG"      ,
+					     dest,"out_BYPASS_MEMORY_"+toString(j               )+"_NUM_REG"      );
+		   COMPONENT_MAP(_component ,src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_DATA"         ,
+				             dest,"out_BYPASS_MEMORY_"+toString(j               )+"_DATA"         );
 
 		   // port map to the "load_store_unit" component
@@ -621,13 +727,13 @@
 #endif
 		   
-		   if (_param->_have_port_ooo_engine_id)
-		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_OOO_ENGINE_ID",
-					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_OOO_ENGINE_ID");
-		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_VAL"          ,
-					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_VAL"          );
-		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_NUM_REG"      ,
-					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_NUM_REG"      );
-		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_DATA"         ,
-					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_DATA"         );
+// 		   if (_param->_have_port_ooo_engine_id)
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_OOO_ENGINE_ID",
+// 					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_OOO_ENGINE_ID");
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_VAL"          ,
+// 					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_VAL"          );
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_NUM_REG"      ,
+// 					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_NUM_REG"      );
+// 		   PORT_MAP(_component ,dest,"out_BYPASS_MEMORY_"+toString(j               )+"_DATA"         ,
+// 					src , "in_BYPASS_MEMORY_"+toString(it_bypass_memory)+"_DATA"         );
 
 		   it_bypass_memory ++;
@@ -651,5 +757,5 @@
 
 	     src = _name+"_functionnal_unit_"+toString(x);
-	     std::cout << "Instance : " << src << std::endl;
+	     log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
 	     
 	     {
@@ -669,50 +775,50 @@
 #ifdef POSITION
 	       _component->interface_map (src ,"execute_in",
-					  dest,"execute_unit_in_"+toString(i));
-#endif
-
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_VAL"                  ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_VAL"                  );
-	       PORT_MAP(_component ,src ,"out_EXECUTE_IN_ACK"                  ,
-				    dest, "in_EXECUTE_UNIT_IN_"+toString(i)+"_ACK"                  );
+					  dest,"execute_unit_in_"+toString(i)+"_0");
+#endif
+
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_VAL"                  ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_VAL"                  );
+	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_IN_ACK"                  ,
+				         dest, "in_EXECUTE_UNIT_IN_"+toString(i)+"_0_ACK"                  );
 	       if (_param->_have_port_context_id)
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_CONTEXT_ID"           ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_CONTEXT_ID"           );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_CONTEXT_ID"           ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_CONTEXT_ID"           );
 	       if (_param->_have_port_front_end_id)
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_FRONT_END_ID"         ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_FRONT_END_ID"         );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_FRONT_END_ID"         ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_FRONT_END_ID"         );
 	       if (_param->_have_port_ooo_engine_id)
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_OOO_ENGINE_ID"        ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_OOO_ENGINE_ID"        );
-	       if (_param->_have_port_packet_id)
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_PACKET_ID"            ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_PACKET_ID"            );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_OPERATION"            ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_OPERATION"            );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_TYPE"                 ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_TYPE"                 );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_STORE_QUEUE_PTR_WRITE",
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_STORE_QUEUE_PTR_WRITE");
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_OOO_ENGINE_ID"        ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_OOO_ENGINE_ID"        );
+	       if (_param->_have_port_rob_ptr  )
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_PACKET_ID"            ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_PACKET_ID"            );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_OPERATION"            ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_OPERATION"            );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_TYPE"                 ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_TYPE"                 );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_STORE_QUEUE_PTR_WRITE",
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_STORE_QUEUE_PTR_WRITE");
 	       if (_param->_have_port_load_queue_ptr)
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_LOAD_QUEUE_PTR_WRITE" ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_LOAD_QUEUE_PTR_WRITE" );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_HAS_IMMEDIAT"         ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_HAS_IMMEDIAT"         );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_IMMEDIAT"             ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_IMMEDIAT"             );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_DATA_RA"              ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_DATA_RA"              );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_DATA_RB"              ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_DATA_RB"              );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_DATA_RC"              ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_DATA_RC"              );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_WRITE_RD"             ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_WRITE_RD"             );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_NUM_REG_RD"           ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_NUM_REG_RD"           );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_WRITE_RE"             ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_WRITE_RE"             );
-	       PORT_MAP(_component ,src , "in_EXECUTE_IN_NUM_REG_RE"           ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_NUM_REG_RE"           );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_LOAD_QUEUE_PTR_WRITE" ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_LOAD_QUEUE_PTR_WRITE" );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_HAS_IMMEDIAT"         ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_HAS_IMMEDIAT"         );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_IMMEDIAT"             ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_IMMEDIAT"             );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_DATA_RA"              ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_DATA_RA"              );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_DATA_RB"              ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_DATA_RB"              );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_DATA_RC"              ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_DATA_RC"              );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_WRITE_RD"             ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_WRITE_RD"             );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_NUM_REG_RD"           ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_NUM_REG_RD"           );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_WRITE_RE"             ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_WRITE_RE"             );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_NUM_REG_RE"           ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_NUM_REG_RE"           );
 	     }
 	     
@@ -723,45 +829,45 @@
 #ifdef POSITION
 	       _component->interface_map (src ,"execute_out",
-					  dest,"execute_unit_out_"+toString(i));
-#endif
-
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_VAL"          ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_VAL"          );
-  	       PORT_MAP(_component ,src , "in_EXECUTE_OUT_ACK"          ,
-				    dest,"out_EXECUTE_UNIT_OUT_"+toString(i)+"_ACK"          );
+					  dest,"execute_unit_out_"+toString(i)+"_0");
+#endif
+
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_VAL"          ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_VAL"          );
+  	       COMPONENT_MAP(_component ,src , "in_EXECUTE_OUT_ACK"          ,
+				         dest,"out_EXECUTE_UNIT_OUT_"+toString(i)+"_0_ACK"          );
 	       if (_param->_have_port_context_id)
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_CONTEXT_ID"   ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_CONTEXT_ID"   );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_CONTEXT_ID"   ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_CONTEXT_ID"   );
 	       if (_param->_have_port_front_end_id)
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_FRONT_END_ID" ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_FRONT_END_ID" );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_FRONT_END_ID" ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_FRONT_END_ID" );
 	       if (_param->_have_port_ooo_engine_id)
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_OOO_ENGINE_ID",
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_OOO_ENGINE_ID");
-	       if (_param->_have_port_packet_id)
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_PACKET_ID"    ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_PACKET_ID"    );
-//	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_OPERATION"    ,
-// 				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_OPERATION"    );
-	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_TYPE"         ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_TYPE"         );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_WRITE_RD"     ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_WRITE_RD"     );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_NUM_REG_RD"   ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_NUM_REG_RD"   );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_DATA_RD"      ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_DATA_RD"      );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_WRITE_RE"     ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_WRITE_RE"     );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_NUM_REG_RE"   ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_NUM_REG_RE"   );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_DATA_RE"      ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_DATA_RE"      );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_EXCEPTION"    ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_EXCEPTION"    );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_NO_SEQUENCE"  ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_NO_SEQUENCE"  );
-  	       PORT_MAP(_component ,src ,"out_EXECUTE_OUT_ADDRESS"      ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_ADDRESS"      );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_OOO_ENGINE_ID",
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_OOO_ENGINE_ID");
+	       if (_param->_have_port_rob_ptr  )
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_PACKET_ID"    ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_PACKET_ID"    );
+//	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_OPERATION"    ,
+// 				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_OPERATION"    );
+	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_TYPE"         ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_TYPE"         );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_WRITE_RD"     ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_WRITE_RD"     );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_NUM_REG_RD"   ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_NUM_REG_RD"   );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_DATA_RD"      ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_DATA_RD"      );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_WRITE_RE"     ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_WRITE_RE"     );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_NUM_REG_RE"   ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_NUM_REG_RE"   );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_DATA_RE"      ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_DATA_RE"      );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_EXCEPTION"    ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_EXCEPTION"    );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_NO_SEQUENCE"  ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_NO_SEQUENCE"  );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_ADDRESS"      ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_ADDRESS"      );
 	     }
 	   }
@@ -773,5 +879,5 @@
   
 	     src = _name+"_load_store_unit_"+toString(x);
-	     std::cout << "Instance : " << src << std::endl;
+	     log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
 
 	     // ~~~~~[ Interface "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
